@ECHO off
SETLOCAL
SETLOCAL EnableDelayedExpansion
COLOR 70
SET batchFilePath=%~dp0
SET "pathSourceL=%~dp0\source\lightweight"
SET "pathSourceN=%~dp0\source\nonlightweight"
SET "pathSourceT=%~dp0\source\templates"
SET pathTargetDir=
SET pathTemplateDir=
FOR %%i IN ("%~dp0..") DO (
	IF NOT EXIST "%%~fi\___Lightweight Mod" (
		ECHO The folder where this .bat is located must be in mods and named '___Lightweight Mod'. This is currently not the case.
		PAUSE >nul
		EXIT
	)
	IF NOT EXIST "%%~fi\dom" (
		ECHO Dawn of Masteries could not be found.
		PAUSE >nul
		EXIT
	)
	SET "pathTargetDir=%%~fi\dom"
	FOR %%a IN ("%%~fi\..") DO (
		IF NOT "%%~nxa"=="Grim Dawn" (
			ECHO You can not use a different working directory than the installation directory of Grim Dawn. Check the README.txt.
			PAUSE >nul
			EXIT
		)
		SET "pathTemplateDir=%%~fa\database\templates"
	)
)
SET destinationSaves=%UserProfile%\Documents\My Games\Grim Dawn\save\user
SET backupLocation=%UserProfile%\Documents\My Games\Grim Dawn\save\_Backup of user (%date%)
SET backupExists=
MKDIR "%backupLocation%"
FOR /F %%i IN ('DIR /b /a "%backupLocation%\*"') DO (
	SET backupExists=^(Already exists^)
    GOTO SKIPBACKUP
)
XCOPY "%destinationSaves%" "%backupLocation%" /e /f /y /q
:SKIPBACKUP
CLS
:START
ECHO This only updates the archives. You only have to run this and you are good to go. & ECHO.
ECHO Type 'light' for the Lightweight version
ECHO Type 'exit' to close the program & ECHO.
SET /p input=^> 
IF "%input:~0,1%"==" " (
	ECHO. & ECHO Command doesn't exist & ECHO.
	ECHO Press Enter to continue
	PAUSE >nul
	CLS
	GOTO :START
)
IF "%input%"=="exit" (
	EXIT
)
IF "%input%"=="light" (
	IF EXIST "%pathTargetDir%\database\records" (
		ECHO. & ECHO The directory 'records' already exists in 'dom\database'^^! This should not be the case with a clean install. & ECHO.
		ECHO Press Enter to continue
		PAUSE >nul
		CLS
		GOTO :START
	)
	ECHO.>> "%pathSourceL%\resources\scripts\main.lua"
	ECHO.--F>> "%pathSourceL%\resources\scripts\main.lua"
	ECHO.>> "%pathSourceL%\resources\scripts\grimmest\grimmest.lua"
	ECHO.--F>> "%pathSourceL%\resources\scripts\grimmest\grimmest.lua"
	archivetool.exe "%pathTargetDir%"\resources\Conversations.arc -update dogconversation.cnv "%pathSourceL%\resources\conversations"
	archivetool.exe "%pathTargetDir%"\resources\Creatures.arc -update ambient "%pathSourceL%\resources\creatures"
	archivetool.exe "%pathTargetDir%"\resources\Scripts.arc -update game "%pathSourceL%\resources\scripts"
	archivetool.exe "%pathTargetDir%"\resources\Scripts.arc -update grimmest "%pathSourceL%\resources\scripts"
	archivetool.exe "%pathTargetDir%"\resources\Scripts.arc -update main.lua "%pathSourceL%\resources\scripts"
	archivetool.exe "%pathTargetDir%"\resources\Text_EN.arc -update __mod.txt "%pathSourceL%\resources\text_en"
	ECHO. Press Enter to close the programm
	PAUSE >nul
	EXIT
) ELSE (
	ECHO. & ECHO Command doesn't exist & ECHO.
	ECHO Press Enter to continue
	PAUSE >nul
	CLS
	GOTO :START
)