gd.modscript = {}

local spawnDelay = Time.Now()
local summonDelay = -900000
local summonDelayLimit = 5000
local is_summoned = false
local amountPlayers = 1

function gd.modscript.giveSummonItem()

	gd.loot.disableItems()
	Game.GetLocalPlayer():TakeItem("records/__mod/summon_item.dbr", 3, false)
	Game.GetLocalPlayer():GiveItem("records/__mod/summon_item.dbr", 1, false)

	if Game.GetLocalPlayer():HasToken("PLAYING_ALTERNATIVE_VERSION") then
		Game.GetLocalPlayer():RemoveToken("PLAYING_ALTERNATIVE_VERSION")
	end

	gd.loot.countSpheres()
	
	UI.Notify("tag_ReceivedSummonItem")
	
end

function gd.modscript.useSummonItem(playerId)

	if amountPlayers < Game.GetNumPlayers() then
		amountPlayers = Game.GetNumPlayers() + 1
		spawnDelay = Time.Now()
	end

	if (Time.Now() - spawnDelay) < 3000 then
		do return end
	end

	if (Time.Now() - gd.loot.returnItemDelay()) < gd.loot.returnItemDelayLimit() then
		do return end
	end
	
	if (Time.Now() - summonDelay) < summonDelayLimit then
		do return end
	end
	
	Game.GetLocalPlayer():TakeItem("records/__mod/summon_item.dbr", 3, false)
	Game.GetLocalPlayer():GiveItem("records/__mod/summon_item.dbr", 1, false)

	summonDelay = Time.Now()
	
	gd.modscript.spawnAnimal()
	is_dog_summoned = true

end

function gd.modscript.spawnAnimal()
	Entity.Create("records/__mod/dog.dbr"):SetCoords(Game.GetLocalPlayer():GetCoords())
	Entity.Create("records/fx/skillsother/aoe/item_novaice_fx01.dbr"):SetCoords(Game.GetLocalPlayer():GetCoords())
	local sound = Character.Create("records/__mod/dog_sound_npc.dbr")
		sound:SetCoords(Game.GetLocalPlayer():GetCoords())
		sound:PlaySound(SoundType.VoxSound)
	UI.Notify("tag_DogSpawned")
end

-- Disables the popping of spheres next to Caravan NPCs
function gd.modscript.spawnTriggerOnStash(objectId)
	Entity.Create("records/__mod/spheres/trigger_disable_spheres.dbr"):SetCoords(Entity.Get(objectId):GetCoords())
end

-- Additional Level Rewards
function gd.modscript.increaseMaxLevel()
	for i = (Game.GetLocalPlayer():GetLevel() - 100),1,-1 do 
		local player_level = i
		local player_token = "MAX_LEVEL_TOKEN_" .. player_level
		
		if not Game.GetLocalPlayer():HasToken(player_token) then
			Game.GetLocalPlayer():GiveToken(player_token)
			do return end
		end
		
	end
end

function gd.modscript.checkMaxLevelAvailable()
	local is_level_available = false

	for i = (Game.GetLocalPlayer():GetLevel() - 100),1,-1 do 
		local player_level = i
		local player_token = "MAX_LEVEL_TOKEN_" .. player_level
		
		if not Game.GetLocalPlayer():HasToken(player_token) then
			is_level_available = true
		end
		
	end
	
	return is_level_available
end

function gd.modscript.getRandomItem(given_table)
	math.randomseed(Time.Now())
    local p = math.random()
    local cumulativeProbability = 0
    for name, item in pairs(given_table) do
        cumulativeProbability = cumulativeProbability + item.probability
        if (p <= cumulativeProbability) then
            return name
        end
    end
end